<!--
title: Three Phase Inverter - Second Service
date: 2016-12-19
-->

I wrote in October about my first try to build a simple three phase inverter, see [here]({{< ref "three-phase-inverter.md" >}}). In the first try I used four MSP430 microcontroller, one for the PWM of each phase and one to coordinate the phase shift of the three phases.

In this experiment I put everything on one STM32 microcontroller. Here I used the DMA feature to feed data into the PWM counter and I calculated the sine values at start-up time on the microcontroller. Additionally I put in the driver for a CAN interface, however, it is not yet supported in the firmware.

![](/static/img_0140.jpg)

From top to bottom you see the CAN driver, the STM32 board, opto coupler to separate logic and power part and then from right to left in the bottom half the low-side/high-side MOSFET drivers and the MOSFETs.

![](/static/img_0144.jpg)

The power supply consists of a traditional transformer and (top right) the rectifier and capacitors for the power part, together with the 12V regulator for the drivers and (top left) the regulators for 3.3V and 5V for the logic part.

![](/static/img_0146.jpg)

The motor is the same as in the earlier experiment - I don't have too much of them. And everything is put onto one board:

![](/static/img_0143-e1482141676335.jpg)

The code for this experiment is here: [https://gitea.hottis.de/wn/inverter2](https://gitea.hottis.de/wn/inverter2).

